#include "mainDemo.h"
extern  void Print_Line_One(BYTE *);
extern  void Print_Line_Two(BYTE *);
extern  void LCDinit_two_line();
extern  void LCDinit_one_line();
extern int line_mode; //1 for 2 lines 0 for one line
extern char LCDText[];
extern DWORD StackStartTime;
extern char time_str[];
extern double Volt_A;
extern double Volt_B;
extern double Volt_C;
extern long ErrorLog_Size;
extern int Display_mode;
extern volatile unsigned long avrms;
extern volatile unsigned long bvrms;
extern volatile unsigned long cvrms;
extern volatile unsigned long airms;
extern volatile unsigned long birms;
extern volatile unsigned long cirms;
extern double Avolt_lsb;
extern double Bvolt_lsb;
extern double Cvolt_lsb;
extern double Aamp_LSB;
extern double Bamp_LSB;
extern double Camp_LSB;
double Volt_A;
double Volt_B;
double Volt_C;
double Amp_A;
double Amp_B;
double Amp_C;
volatile unsigned long avrms;
volatile unsigned long bvrms;
volatile unsigned long cvrms;
volatile unsigned long airms;
volatile unsigned long birms;
volatile unsigned long cirms;
extern double ALLamp_lsb;        
extern void ConvertUtcSecToString(DWORD , char*);
extern POWER_READINGS PowerReadings;
extern double wh_lsb;
int thumbsavenumber =0;
char ipString[20];
char * IPToString(IP_ADDR ip)
{
	BYTE digits[4];
	BYTE i;
//bob	char ipString[20];
	memset(ipString,0x00,20);
	for(i = 0; i < 4u; i++)
	{
		if(i)
			strcat(ipString,".");
		uitoa(ip.v[i], digits);
		strcat(ipString,((const char*) digits));
	}
return ipString;
}

void Display_Mode(int mode,POWER_READINGS * PowerReads )
{

	char hour[2];
	char min_sec[6];
	char ttt[1];
	char my_year[10];
	
	 
    switch( mode )
    {
        case 0: // name and ip
        
        	if (line_mode == 0)
        	{
	        	LCDinit_two_line();
	        	line_mode = 1;
	        }
			//double meterReading = PowerReads->Starting_Meter_Reading/1000;
			strcpy(LCDText,"Name:");
			strcat(LCDText,(char *)AppConfig.NetBIOSName);
            Print_Line_One((BYTE *)LCDText);
			memset(LCDText,0x00,20);
			strcpy(LCDText,"IP:");
            strcat(LCDText,IPToString(AppConfig.MyIPAddr));
			Print_Line_Two((BYTE *)LCDText);
            break;

	




        case 1:  // display A,B,C loads
        
            if (line_mode == 0)
        	{
	        	LCDinit_two_line();
	        	line_mode = 1;
	        }
		
			sprintf(LCDText,"WATT LOAD A=%d ",PowerReadings.Watt_Load_A) ;
			Print_Line_One((BYTE *)LCDText);
            sprintf(LCDText,"B=%d C=%d" ,PowerReadings.Watt_Load_B,PowerReadings.Watt_Load_C);
			Print_Line_Two((BYTE *)LCDText);
			
            
          break;
		case 2:  // display A,B,C accumulated
        
            if (line_mode == 0)
        	{
	        	LCDinit_two_line();
	        	line_mode = 1;
	        }
			sprintf(LCDText,"WATTS USED A=%.0f",PowerReadings.Accum_A_Reg*wh_lsb);
			Print_Line_One((BYTE *)LCDText);
            sprintf(LCDText,"B=%.0f C=%.0f" ,PowerReadings.Accum_B_Reg*wh_lsb,PowerReadings.Accum_C_Reg*wh_lsb);
			Print_Line_Two((BYTE *)LCDText);
			
            
          break;
        case 3: // time date and error log size
        		if (line_mode == 0)
        		{
	        		LCDinit_two_line();
	        		line_mode = 1;
	        	}
        		StackStartTime = SNTPGetUTCSeconds();
            	ConvertUtcSecToString(StackStartTime, (char*) time_str);
				sscanf(time_str,"%10c%1c%2c%6c",(BYTE *)my_year,(BYTE *)ttt,(BYTE *)hour,(BYTE *)min_sec);
				sprintf(LCDText,"%.10s  Log Size" ,my_year);
				Print_Line_One((BYTE *)LCDText);
				sprintf(LCDText,"%.2s%.6s    %lu" ,hour,min_sec,ErrorLog_Size);
				Nop();
				
				
				Print_Line_Two((BYTE *)LCDText);
			break;

        case 4:  // print ip
        		if (line_mode == 1)
        	{
	        	LCDinit_one_line();
	        	line_mode = 0;
	        }
        
        		DisplayIPValue(AppConfig.MyIPAddr);
        	  
        	         
            break;

        
       
        case 5:   
        
        	if (line_mode == 0)
        	{
	        	LCDinit_two_line();
	        	line_mode = 1;
	        }
			
	        Volt_A=avrms*Avolt_lsb;
			Volt_B=bvrms*Bvolt_lsb;
			Volt_C=cvrms*Cvolt_lsb;
            sprintf(LCDText,"VOLTS A =%.2f " ,Volt_A);
			Print_Line_One((BYTE *)LCDText);
			sprintf(LCDText,"B =%.2f C =%.2f" ,Volt_B,Volt_C);
			Print_Line_Two((BYTE *)LCDText);
            break;
   
		case 6:   
        
        	if (line_mode == 0)
        	{
	        	LCDinit_two_line();
	        	line_mode = 1;
	        }
	       
			Amp_A =airms*Aamp_LSB;
			Amp_B =birms*Bamp_LSB;
			Amp_C =cirms*Camp_LSB;
            sprintf(LCDText,"AMPS A =%.1f " ,Amp_A );
			Print_Line_One((BYTE *)LCDText);
			sprintf(LCDText,"B =%.1f C =%.1f",Amp_B ,Amp_C );
			Print_Line_Two((BYTE *)LCDText);
            break;
        


		case 7:	// Save cal settings


			if (line_mode == 0)
        	{
	        	LCDinit_two_line();
	        	line_mode = 1;
	        }
		
	        sprintf(LCDText,"TO SAVE CAL PUSH GRN");
			Print_Line_One((BYTE *)LCDText);
			sprintf(LCDText,"ELSE PUSH RED");
			Print_Line_Two((BYTE *)LCDText);

			if(GREEN_BUTTON_IO == 0)  // GREEN button pushed
			{	
			
		   		Display_mode = 8;
			}
				break;
	
				
			


        case 8:
         
				if(SaveCalvaluesOnThumbDrive())
				{
						LCDinit_two_line();
		 	       		sprintf(LCDText,"Cal Settings Saved");
						Print_Line_One((BYTE *)LCDText);
						sprintf(LCDText,"To cal.txt");
						Print_Line_Two((BYTE *)LCDText);
				}
				else
				{
						LCDinit_two_line();
		 	       		sprintf(LCDText,"Cal Settings Not");
						Print_Line_One((BYTE *)LCDText);
						sprintf(LCDText,"Saved to file");
						Print_Line_Two((BYTE *)LCDText);

				}



           		Display_mode = 0;
           	
           		
			 break;


			default:
        
            break;

    }



}

    

