#!/bin/sh
#-- overhead
export GDFONTPATH="/usr/share/fonts/truetype/"
base="${1%.*}"
echo Base name: ${base}
ofile=${base}.png
echo Input file: $1
echo Output file: ${ofile}
#-- do it
gnuplot << EOF
#set term x11
set term png font "arialbd.ttf" 18 size 950,600
set output "${ofile}"
set title "${base}"
set key noautotitles
unset mouse
set grid ytics
set style data histogram
set style histogram clustered gap 1
set style fill solid border lt -1
set title "Hall Effect Sensor Calibration"
set xlabel "Sensor Output - mV"
set ylabel "Count"
set format y "%2.0f"
#set yrange [0:15]
set label 10 "Magnetic field = 32 G" at 14,9 right
set label 1 "49E 231B" at 4.5,9 right
set label 2 "AH49E" at 12.5,3 left
set arrow from 5.5,5 to 10.5,5 heads filled front lw 2
set label 3 "SS49E Spec" at 8.0,5.5 center
set arrow from 3.0,4 to 7,4 heads filled front lw 2
set label 4 "SS49 Spec" at 6.0,3.25 left
plot	\
    '$1' using 2:xticlabels(1)
EOF